org.springframework.util

## Class ConcurrentReferenceHashMap<K,V>

- java.lang.Object
- - java.util.AbstractMap<K,V>
  - - org.springframework.util.ConcurrentReferenceHashMap<K,V>

Type Parameters:
  `K` - The key type
  `V` - The value type

All Implemented Interfaces:
  ConcurrentMap<K,V>, Map<K,V>

    public class ConcurrentReferenceHashMap<K,V>
    extends AbstractMap<K,V>
    implements ConcurrentMap<K,V>

A `ConcurrentHashMap` that uses `soft` or weak references for both `keys` and `values`.

This class can be used as an alternative to `Collections.synchronizedMap(new WeakHashMap<K, Reference<V>>())` in order to support better performance when accessed concurrently. This implementation follows the same design constraints as `ConcurrentHashMap` with the exception that `null` values and `null` keys are supported.

NOTE: The use of references means that there is no guarantee that items placed into the map will be subsequently available. The garbage collector may discard references at any time, so it may appear that an unknown thread is silently removing entries.

If not explicitly specified this implementation will use soft entry references.

Since:
  3.2
Author:
  Phillip Webb

### Nested Class Summary

Nested Classes
`protected static class` `ConcurrentReferenceHashMap.Entry<K,V>` A single map entry.
`protected static interface` `ConcurrentReferenceHashMap.Reference<K,V>` A reference to an `ConcurrentReferenceHashMap.Entry` contained in the map.
`protected class` `ConcurrentReferenceHashMap.ReferenceManager` Strategy class used to manage `ConcurrentReferenceHashMap.Reference`s.
`static class` `ConcurrentReferenceHashMap.ReferenceType` Various reference types supported by this map.
`protected static class` `ConcurrentReferenceHashMap.Restructure` The types of restructuring that can be performed.
`protected class` `ConcurrentReferenceHashMap.Segment` A single segment used to divide the map to allow better concurrent performance.

### Nested classes/interfaces inherited from class java.util.AbstractMap

`AbstractMap.SimpleEntry<K,V>, AbstractMap.SimpleImmutableEntry<K,V>`

### Constructor Summary

Constructors
Constructor and Description
`ConcurrentReferenceHashMap()` Create a new `ConcurrentReferenceHashMap` instance.
`ConcurrentReferenceHashMap(int initialCapacity)` Create a new `ConcurrentReferenceHashMap` instance.
`ConcurrentReferenceHashMap(int initialCapacity, float loadFactor)` Create a new `ConcurrentReferenceHashMap` instance.
`ConcurrentReferenceHashMap(int initialCapacity, float loadFactor, int concurrencyLevel)` Create a new `ConcurrentReferenceHashMap` instance.
`ConcurrentReferenceHashMap(int initialCapacity, float loadFactor, int concurrencyLevel, ConcurrentReferenceHashMap.ReferenceType referenceType)` Create a new `ConcurrentReferenceHashMap` instance.
`ConcurrentReferenceHashMap(int initialCapacity, int concurrencyLevel)` Create a new `ConcurrentReferenceHashMap` instance.

### Method Summary

Methods
`protected static int` `calculateShift(int minimumValue, int maximumValue)` Calculate a shift value that can be used to create a power-of-two value between the specified maximum and minimum values.
`void` `clear()`
`boolean` `containsKey(Object key)`
`protected ConcurrentReferenceHashMap.ReferenceManager` `createReferenceManager()` Factory method that returns the `ConcurrentReferenceHashMap.ReferenceManager`.
`Set<Map.Entry<K,V>>` `entrySet()`
`V` `get(Object key)`
`protected int` `getHash(Object o)` Get the hash for a given object, apply an additional hash function to reduce collisions.
`protected float` `getLoadFactor()`
`protected ConcurrentReferenceHashMap.Reference<K,V>` `getReference(Object key, ConcurrentReferenceHashMap.Restructure restructure)` Returns a `ConcurrentReferenceHashMap.Reference` to the `ConcurrentReferenceHashMap.Entry` for the specified `key` or `null` if not found.
`protected ConcurrentReferenceHashMap.Segment` `getSegment(int index)`
`protected int` `getSegmentsSize()`
`V` `put(K key, V value)`
`V` `putIfAbsent(K key, V value)`
`V` `remove(Object key)`
`boolean` `remove(Object key, Object value)`
`V` `replace(K key, V value)`
`boolean` `replace(K key, V oldValue, V newValue)`
`int` `size()`

### Methods inherited from class java.util.AbstractMap

`clone, containsValue, equals, hashCode, isEmpty, keySet, putAll, toString, values`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.Map

`containsValue, equals, hashCode, isEmpty, keySet, putAll, values`

### Constructor Detail

#### ConcurrentReferenceHashMap

    public ConcurrentReferenceHashMap()

Create a new `ConcurrentReferenceHashMap` instance.

#### ConcurrentReferenceHashMap

    public ConcurrentReferenceHashMap(int initialCapacity)

Create a new `ConcurrentReferenceHashMap` instance.

Parameters:
  `initialCapacity` - the initial capacity of the map

#### ConcurrentReferenceHashMap

    public ConcurrentReferenceHashMap(int initialCapacity,
                              float loadFactor)

Create a new `ConcurrentReferenceHashMap` instance.

Parameters:
  `initialCapacity` - the initial capacity of the map
  `loadFactor` - the load factor. When the average number of references per table exceeds this value resize will be attempted

#### ConcurrentReferenceHashMap

    public ConcurrentReferenceHashMap(int initialCapacity,
                              int concurrencyLevel)

Create a new `ConcurrentReferenceHashMap` instance.

Parameters:
  `initialCapacity` - the initial capacity of the map
  `concurrencyLevel` - the expected number of threads that will concurrently write to the map

#### ConcurrentReferenceHashMap

    public ConcurrentReferenceHashMap(int initialCapacity,
                              float loadFactor,
                              int concurrencyLevel)

Create a new `ConcurrentReferenceHashMap` instance.

Parameters:
  `initialCapacity` - the initial capacity of the map
  `loadFactor` - the load factor. When the average number of references per table exceeds this value resize will be attempted
  `concurrencyLevel` - the expected number of threads that will concurrently write to the map

#### ConcurrentReferenceHashMap

    public ConcurrentReferenceHashMap(int initialCapacity,
                              float loadFactor,
                              int concurrencyLevel,
                              ConcurrentReferenceHashMap.ReferenceType referenceType)

Create a new `ConcurrentReferenceHashMap` instance.

Parameters:
  `initialCapacity` - the initial capacity of the map
  `loadFactor` - the load factor. When the average number of references per table exceeds this value resize will be attempted
  `concurrencyLevel` - the expected number of threads that will concurrently write to the map
  `referenceType` - the reference type used for entries

### Method Detail

#### getLoadFactor

    protected final float getLoadFactor()

#### getSegmentsSize

    protected final int getSegmentsSize()

#### getSegment

    protected final ConcurrentReferenceHashMap.Segment getSegment(int index)

#### createReferenceManager

    protected ConcurrentReferenceHashMap.ReferenceManager createReferenceManager()

Factory method that returns the `ConcurrentReferenceHashMap.ReferenceManager`. This method will be called once for each `ConcurrentReferenceHashMap.Segment`.

Returns:
  a new reference manager

#### getHash

    protected int getHash(Object o)

Get the hash for a given object, apply an additional hash function to reduce collisions. This implementation uses the same Wang/Jenkins algorithm as `ConcurrentHashMap`. Subclasses can override to provide alternative hashing.

Parameters:
  `o` - the object to hash (may be null)
Returns:
  the resulting hash code

#### get

    public V get(Object key)

Specified by:
  `get` in interface `Map<K,V>`
Overrides:
  `get` in class `AbstractMap<K,V>`

#### containsKey

    public boolean containsKey(Object key)

Specified by:
  `containsKey` in interface `Map<K,V>`
Overrides:
  `containsKey` in class `AbstractMap<K,V>`

#### getReference

    protected final ConcurrentReferenceHashMap.Reference<K,V> getReference(Object key,
                                                         ConcurrentReferenceHashMap.Restructure restructure)

Returns a `ConcurrentReferenceHashMap.Reference` to the `ConcurrentReferenceHashMap.Entry` for the specified `key` or `null` if not found.

Parameters:
  `key` - the key (can be `null`)
  `restructure` - types of restructure allowed during this call
Returns:
  the reference or `null`

#### put

    public V put(K key,
        V value)

Specified by:
  `put` in interface `Map<K,V>`
Overrides:
  `put` in class `AbstractMap<K,V>`

#### putIfAbsent

    public V putIfAbsent(K key,
                V value)

Specified by:
  `putIfAbsent` in interface `ConcurrentMap<K,V>`

#### remove

    public V remove(Object key)

Specified by:
  `remove` in interface `Map<K,V>`
Overrides:
  `remove` in class `AbstractMap<K,V>`

#### remove

    public boolean remove(Object key,
                 Object value)

Specified by:
  `remove` in interface `ConcurrentMap<K,V>`

#### replace

    public boolean replace(K key,
                  V oldValue,
                  V newValue)

Specified by:
  `replace` in interface `ConcurrentMap<K,V>`

#### replace

    public V replace(K key,
            V value)

Specified by:
  `replace` in interface `ConcurrentMap<K,V>`

#### clear

    public void clear()

Specified by:
  `clear` in interface `Map<K,V>`
Overrides:
  `clear` in class `AbstractMap<K,V>`

#### size

    public int size()

Specified by:
  `size` in interface `Map<K,V>`
Overrides:
  `size` in class `AbstractMap<K,V>`

#### entrySet

    public Set<Map.Entry<K,V>> entrySet()

Specified by:
  `entrySet` in interface `Map<K,V>`
Specified by:
  `entrySet` in class `AbstractMap<K,V>`

#### calculateShift

    protected static int calculateShift(int minimumValue,
                     int maximumValue)

Calculate a shift value that can be used to create a power-of-two value between the specified maximum and minimum values.

Parameters:
  `minimumValue` - the minimum value
  `maximumValue` - the maximum value
Returns:
  the calculated shift (use `1 << shift` to obtain a value)